aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDanilo Macrì <danix@danix.xyz>2026-03-30 18:10:09 -0400
committerGitHub <noreply@github.com>2026-03-30 18:10:09 -0400
commiteda518ec01fe97abe77b0be790ef5ab4cfe16439 (patch)
tree6a1d5fbf82167d5c3cd20b203dce962960e17942
parent691abf1c1e7f18b1607b7a2ec26537abfd666cf8 (diff)
parente553c5ea90ce1cf6cafc58bf8ed905036dd343ae (diff)
downloadmy-slackbuilds-eda518ec01fe97abe77b0be790ef5ab4cfe16439.tar.gz
my-slackbuilds-eda518ec01fe97abe77b0be790ef5ab4cfe16439.zip
Merge pull request #2 from danixland/qarma
qarma: add version 1.0.0
-rw-r--r--qarma/LICENSE339
-rw-r--r--qarma/README.md17
-rw-r--r--qarma/image-preview.patch158
-rw-r--r--qarma/qarma.SlackBuild220
-rw-r--r--qarma/qarma.info10
-rw-r--r--qarma/slack-desc19
6 files changed, 763 insertions, 0 deletions
diff --git a/qarma/LICENSE b/qarma/LICENSE
new file mode 100644
index 0000000..22fbe5d
--- /dev/null
+++ b/qarma/LICENSE
@@ -0,0 +1,339 @@
+GNU GENERAL PUBLIC LICENSE
+ Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc., <http://fsf.org/>
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+ Preamble
+
+ The licenses for most software are designed to take away your
+freedom to share and change it. By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users. This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it. (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.) You can apply it to
+your programs, too.
+
+ When we speak of free software, we are referring to freedom, not
+price. Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+ To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+ For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have. You must make sure that they, too, receive or can get the
+source code. And you must show them these terms so they know their
+rights.
+
+ We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+ Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software. If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+ Finally, any free program is threatened constantly by software
+patents. We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary. To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+ The precise terms and conditions for copying, distribution and
+modification follow.
+
+ GNU GENERAL PUBLIC LICENSE
+ TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+ 0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License. The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language. (Hereinafter, translation is included without limitation in
+the term "modification".) Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope. The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+ 1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+ 2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+ a) You must cause the modified files to carry prominent notices
+ stating that you changed the files and the date of any change.
+
+ b) You must cause any work that you distribute or publish, that in
+ whole or in part contains or is derived from the Program or any
+ part thereof, to be licensed as a whole at no charge to all third
+ parties under the terms of this License.
+
+ c) If the modified program normally reads commands interactively
+ when run, you must cause it, when started running for such
+ interactive use in the most ordinary way, to print or display an
+ announcement including an appropriate copyright notice and a
+ notice that there is no warranty (or else, saying that you provide
+ a warranty) and that users may redistribute the program under
+ these conditions, and telling the user how to view a copy of this
+ License. (Exception: if the Program itself is interactive but
+ does not normally print such an announcement, your work based on
+ the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole. If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works. But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+ 3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+ a) Accompany it with the complete corresponding machine-readable
+ source code, which must be distributed under the terms of Sections
+ 1 and 2 above on a medium customarily used for software interchange; or,
+
+ b) Accompany it with a written offer, valid for at least three
+ years, to give any third party, for a charge no more than your
+ cost of physically performing source distribution, a complete
+ machine-readable copy of the corresponding source code, to be
+ distributed under the terms of Sections 1 and 2 above on a medium
+ customarily used for software interchange; or,
+
+ c) Accompany it with the information you received as to the offer
+ to distribute corresponding source code. (This alternative is
+ allowed only for noncommercial distribution and only if you
+ received the program in object code or executable form with such
+ an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it. For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable. However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+ 4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License. Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+ 5. You are not required to accept this License, since you have not
+signed it. However, nothing else grants you permission to modify or
+distribute the Program or its derivative works. These actions are
+prohibited by law if you do not accept this License. Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+ 6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions. You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+ 7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License. If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all. For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices. Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+ 8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded. In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+ 9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time. Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation. If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+ 10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission. For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this. Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+ NO WARRANTY
+
+ 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+ 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+ END OF TERMS AND CONDITIONS
+
+ How to Apply These Terms to Your New Programs
+
+ If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+ To do so, attach the following notices to the program. It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+ {description}
+ Copyright (C) {year} {fullname}
+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License along
+ with this program; if not, write to the Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+ Gnomovision version 69, Copyright (C) year name of author
+ Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+ This is free software, and you are welcome to redistribute it
+ under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License. Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary. Here is a sample; alter the names:
+
+ Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+ `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+ {signature of Ty Coon}, 1 April 1989
+ Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs. If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library. If this is what you want to do, use the GNU Lesser General
+Public License instead of this License. \ No newline at end of file
diff --git a/qarma/README.md b/qarma/README.md
new file mode 100644
index 0000000..22a95c2
--- /dev/null
+++ b/qarma/README.md
@@ -0,0 +1,17 @@
+qarma
+=====
+
+Qarma is a tool to create dialog boxes, based on Qt.
+It's a clone of Zenity which was written for GTK+.
+
+
+Q: Why do you waste time cloning a perfectly fine tool?
+
+A:
+"The answer is that GTK+ is primarily intended to be used on the GNOME desktop"
+"GTK+ must focus on being the toolkit of the GNOME platform first, and tackle integration second."
+
+See this [LWN Article](https://lwn.net/Articles/562856/) and this [blog post](http://blogs.gnome.org/mclasen/2014/03/21/dialogs-in-gtk-3-12/).
+
+Q: Does the name mean anything?
+A: Yes.
diff --git a/qarma/image-preview.patch b/qarma/image-preview.patch
new file mode 100644
index 0000000..01799bb
--- /dev/null
+++ b/qarma/image-preview.patch
@@ -0,0 +1,158 @@
+From 425ae90cae55f9136e0620c3165baf839e54bc0a Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Thomas=20L=C3=BCbking?= <thomas.luebking@gmail.com>
+Date: Fri, 26 Dec 2025 18:54:33 +0100
+Subject: [PATCH] add option or preview images in file dialogs
+
+closes #57
+---
+ Qarma.cpp | 96 ++++++++++++++++++++++++++++++++++++++++++++++++++++++-
+ 1 file changed, 95 insertions(+), 1 deletion(-)
+
+diff --git a/Qarma.cpp b/Qarma.cpp
+index 3708360..c0f1f77 100644
+--- a/Qarma.cpp
++++ b/Qarma.cpp
+@@ -24,6 +24,7 @@
+ #include <QCheckBox>
+ #include <QColorDialog>
+ #include <QComboBox>
++#include <QCryptographicHash>
+ #include <QDate>
+ #include <QDBusConnection>
+ #include <QDBusConnectionInterface>
+@@ -34,6 +35,7 @@
+ #include <QFontDialog>
+ #include <QFormLayout>
+ #include <QIcon>
++#include <QImageReader>
+ #include <QInputDialog>
+ #include <QLabel>
+ #include <QLocale>
+@@ -42,12 +44,15 @@
+ #include <QProcess>
+ #include <QProgressDialog>
+ #include <QPropertyAnimation>
++#include <QProxyStyle>
+ #include <QPushButton>
+ #include <QScreen>
+ #include <QScrollBar>
+ #include <QSettings>
+ #include <QSlider>
+ #include <QSocketNotifier>
++#include <QSplitter>
++#include <QStandardPaths>
+ #include <QStringBuilder>
+ #include <QStringList>
+ #include <QTextBrowser>
+@@ -785,6 +790,83 @@ char Qarma::showMessage(const QStringList &args, char type)
+ return 0;
+ }
+
++QPixmap thumbnail(const QString &path, uint size)
++{
++ size = qMin(size, 1024u);
++ QImage thumb;
++ QImageReader thumbReader;
++ thumbReader.setFileName(path);
++ if (!thumbReader.canRead())
++ return QPixmap();
++
++ thumbReader.setQuality(50);
++ QSize sz = thumbReader.size();
++ QSize origSz = sz;
++ bool skipThumbnail = sz.width()*sz.height() < 1920*1200+1;
++
++ if (skipThumbnail) {
++ sz.scale(QSize(size,size), Qt::KeepAspectRatio);
++ thumbReader.setScaledSize(sz);
++ } else {
++ QFileInfo info(path);
++ QString canonicalPath = info.canonicalFilePath();
++ if (canonicalPath.isEmpty())
++ canonicalPath = info.absoluteFilePath();
++ QUrl url = QUrl::fromLocalFile(canonicalPath);
++ QCryptographicHash md5(QCryptographicHash::Md5);
++ md5.addData(QFile::encodeName(url.adjusted(QUrl::RemovePassword).url()));
++
++ QString folder;
++ uint tSize;
++ if (size <= 128) {
++ tSize = 128; folder = "normal/";
++ } else if (size <= 256) {
++ tSize = 256; folder = "large/";
++ } else if (size <= 512) {
++ tSize = 512; folder = "x-large/";
++ } else {
++ tSize = 1024; folder = "xx-large/";
++ }
++ Q_UNUSED(tSize);
++
++ const QString thumbPath = QStandardPaths::writableLocation(QStandardPaths::GenericCacheLocation) +
++ QLatin1String("/thumbnails/") + folder +
++ QString::fromLatin1(md5.result().toHex()) + QStringLiteral(".png");
++ QFileInfo tInfo(thumbPath);
++ if (tInfo.exists() && info.metadataChangeTime() <= tInfo.lastModified() && info.lastModified() <= tInfo.lastModified()) {
++ thumbReader.setFileName(thumbPath);
++ sz.scale(QSize(size,size), Qt::KeepAspectRatio);
++ thumbReader.setScaledSize(sz);
++ if (thumbReader.read(&thumb)) {
++ int w = thumb.text("Thumb::Image::Width").toInt();
++ int h = thumb.text("Thumb::Image::Height").toInt();
++ if (origSz == QSize(w, h))
++ return QPixmap::fromImage(thumb);
++ }
++ }
++ thumbReader.setFileName(path);
++// sz.scale(QSize(tSize,tSize), Qt::KeepAspectRatio); // in case we'll ever store the thumbnail
++ sz.scale(QSize(size,size), Qt::KeepAspectRatio);
++ thumbReader.setScaledSize(sz);
++ }
++ if (!thumbReader.read(&thumb))
++ return QPixmap();
++// if (skipThumbnail)
++ return QPixmap::fromImage(thumb);
++}
++
++class DblClckStyle : public QProxyStyle
++{
++ public:
++ int styleHint(StyleHint hint, const QStyleOption *option = nullptr,
++ const QWidget *widget = nullptr, QStyleHintReturn *returnData = nullptr) const override
++ {
++ if (hint == QStyle::SH_ItemView_ActivateItemOnSingleClick)
++ return false;
++ return QProxyStyle::styleHint(hint, option, widget, returnData);
++ }
++};
++
+ char Qarma::showFileSelection(const QStringList &args)
+ {
+ QFileDialog *dlg = new QFileDialog;
+@@ -827,6 +909,17 @@ char Qarma::showFileSelection(const QStringList &args)
+ if (idx > -1)
+ mimeFilter = mimeFilter.left(idx).trimmed() + " (" + mimeFilter.mid(idx+1).trimmed() + ")";
+ mimeFilters << mimeFilter;
++ } else if (args.at(i) == "--preview-images") {
++ READ_INT(size, UInt, "--preview-images must be followed by a positive number for the thumbnail size");
++ dlg->setOption(QFileDialog::DontUseNativeDialog);
++ if (QSplitter *splitter = dlg->findChild<QSplitter*>()) {
++ qApp->setStyle(new DblClckStyle);
++ QLabel *preview = new QLabel(splitter);
++ splitter->addWidget(preview);
++ connect(dlg, &QFileDialog::currentChanged, [=](const QString &path) {
++ preview->setPixmap(thumbnail(path, size));
++ });
++ }
+ }
+ else { WARN_UNKNOWN_ARG("--file-selection") }
+ }
+@@ -1815,7 +1908,8 @@ void Qarma::printHelp(const QString &category)
+ Help("--save", tr("Activate save mode")) <<
+ Help("--separator=SEPARATOR", tr("Set output separator character")) <<
+ Help("--confirm-overwrite", tr("Confirm file selection if filename already exists")) <<
+- Help("--file-filter=NAME | PATTERN1 PATTERN2 ...", tr("Sets a filename filter")));
++ Help("--file-filter=NAME | PATTERN1 PATTERN2 ...", tr("Sets a filename filter")) <<
++ Help("--preview-images=SIZE", "QARMA ONLY! " + tr("Show image thumbnails of SIZE")));
+ helpDict["list"] = CategoryHelp(tr("List Command\n %1 --list [Options] [Item1 ...]\nList Options").arg(applicationName()), HelpList() <<
+ Help("--text=TEXT", tr("Set the dialog text")) <<
+ Help("--column=COLUMN", tr("Set the column header")) <<
diff --git a/qarma/qarma.SlackBuild b/qarma/qarma.SlackBuild
new file mode 100644
index 0000000..c313881
--- /dev/null
+++ b/qarma/qarma.SlackBuild
@@ -0,0 +1,220 @@
+#!/bin/sh
+# Generated by Alien's SlackBuild Toolkit: http://slackware.com/~alien/AST
+# Copyright 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018 Eric Hameleers, Eindhoven, Netherlands
+# Copyright 2018 danix <danix@danix.xyz>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: danix <danix@danix.xyz>
+# For: qarma
+# Descr: zenity clone for QT4/QT5
+# URL: https://github.com/luebking/qarma
+# Build needs:
+# Needs:
+# Changelog:
+# git-1: 11/Jun/2018 by danix <danix@danix.xyz>
+# * Initial build.
+#
+# Run 'sh qarma.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=qarma
+VERSION=${VERSION:-1.0.0}
+BUILD=${BUILD:-4}
+# 'make' can run jobs in parallel for added speed. The number should be higher
+# than the number of cores/virtual CPU's in your system:
+NUMJOBS=${NUMJOBS:-" -j4 "}
+# The TAG is a unique identifier for all your Slackware packages.
+# Use your initials as the value for TAG for instance.
+TAG=${TAG:-_danix}
+
+# This covers most filenames you'd want as documentation. Change if needed.
+DOCS="LICENSE README.md"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Input URL: https://github.com/luebking/qarma/archive/master.zip
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# You can use your own private machine.conf file to overrule machine defaults:
+if [ -e $SRCDIR/machine.conf ]; then
+ . $SRCDIR/machine.conf
+elif [ -e /etc/slackbuild/machine.conf ]; then
+ . /etc/slackbuild/machine.conf
+else
+ # Automatically determine the architecture we're building on:
+ if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+ fi
+ # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+ case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+ esac
+fi
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+# Explode the package framework:
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ cd $PKG
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
+ cd -
+fi
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+# Apply patches
+if [ -f $SRCDIR/*.patch ]; then
+ echo "Applying Patches"
+ for PATCH in $SRCDIR/*.patch; do
+ echo "Patch: $PATCH"
+ patch -p1 -i $PATCH
+ done
+fi
+
+echo Building ...
+mkdir -p build-${PRGNAM}
+cd build-${PRGNAM}
+ qmake6 ..
+ make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+ mkdir -p $PKG/usr/bin
+ install qarma $PKG/usr/bin 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+cd -
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Compress info pages and remove the package's dir file:
+if [ -d $PKG/usr/info ]; then
+ rm -f $PKG/usr/info/dir
+ gzip -9f $PKG/usr/info/*.info*
+ # If any info files are present, consider adding this to a doinst.sh
+ # (replacing XXXXX with whatever files you find):
+ # chroot . install-info /usr/info/XXXXX.info.gz /usr/info/dir 2> /dev/null
+fi
+
+# Strip binaries (if any):
+#find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+# | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+strip --strip-unneeded $PKG/usr/bin/qarma 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+elif [ -f $SRCDIR/doinst.sh.gz ]; then
+ zcat $SRCDIR/doinst.sh.gz >> $PKG/install/doinst.sh
+fi
+if [ -f $SRCDIR/slack-required ]; then
+ cat $SRCDIR/slack-required > $PKG/install/slack-required
+fi
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+fi
+
+# Restore the original umask:
+umask ${_UMASK_}
diff --git a/qarma/qarma.info b/qarma/qarma.info
new file mode 100644
index 0000000..b208444
--- /dev/null
+++ b/qarma/qarma.info
@@ -0,0 +1,10 @@
+PRGNAM="qarma"
+VERSION="1.0.0"
+HOMEPAGE="https://github.com/luebking/qarma"
+DOWNLOAD="https://github.com/luebking/qarma/archive/refs/tags/v1.0.0.tar.gz"
+MD5SUM="a49677d61874cd050eff8b2b1a28f01d"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="danix"
+EMAIL="danix@danix.xyz"
diff --git a/qarma/slack-desc b/qarma/slack-desc
new file mode 100644
index 0000000..fb56765
--- /dev/null
+++ b/qarma/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler----------------------------------------------------|
+qarma: Qarma, a near perfect zenity clone
+qarma:
+qarma: Qarma is a near perfect zenity clone, written in Qt,
+qarma: could be compiled against Qt6, Qt5 and Qt4, and supports styling
+qarma: with qt5ct and qt6ct.
+qarma:
+qarma: Q: Why do you waste time cloning a perfectly fine tool?
+qarma: A: "The answer is that GTK+ is primarily intended to be used on
+qarma: the GNOME desktop. GTK+ must focus on being the toolkit of
+qarma: the GNOME platform first, and tackle integration second."
+qarma: Website: https://github.com/luebking/qarma